%define anolis_release 1
%global srcname execnet
%bcond_with check

Name:           python-%{srcname}
Version:        1.9.0
Release:        %{anolis_release}%{?dist}
Summary:        Distributed Python deployment and communication
License:        MIT
URL:            https://github.com/pytest-dev/execnet
Source0:        %pypi_source

BuildArch:      noarch
BuildRequires:  make
BuildRequires:  %{_bindir}/ps

%description
execnet provides a share-nothing model with channel-send/receive
communication for distributing execution across many Python
interpreters across version, platform and network barriers. It has a
minimal and fast API targetting the following uses:

 * distribute tasks to (many) local or remote CPUs
 * write and deploy hybrid multi-process applications
 * write scripts to administer multiple environments


%package -n python3-%{srcname}
Summary:        Elastic Python Deployment
BuildRequires:  python3-devel
BuildRequires:  python3-setuptools
BuildRequires:  python3-setuptools_scm
BuildRequires:  python3-py
BuildRequires:  python3-pytest
#BuildRequires:  python3-eventlet -- not yet ready for Python 3.10
BuildRequires:  python3-gevent
BuildRequires:  python3-pytest-timeout
BuildRequires:  %{_bindir}/sphinx-build-3

%description -n python3-%{srcname}
execnet provides a share-nothing model with channel-send/receive
communication for distributing execution across many Python
interpreters across version, platform and network barriers. It has a
minimal and fast API targetting the following uses:

 * distribute tasks to (many) local or remote CPUs
 * write and deploy hybrid multi-process applications
 * write scripts to administer multiple environments

%package -n python3-%{srcname}-doc
Summary:        %{summary}
Requires:	python3-%{srcname} = %{version}-%{release}

%description -n python3-%{srcname}-doc
Doc files for python3-%{srcname}

%prep
%autosetup -p1 -n %{srcname}-%{version}
# remove shebangs and fix permissions
find . -type f -a \( -name '*.py' -o -name 'py.*' \) \
   -exec sed -i '1{/^#!/d}' {} \; \
   -exec chmod u=rw,go=r {} \;


%build
export SETUPTOOLS_SCM_PRETEND_VERSION=%{version}
%py3_build
make -C doc html PYTHONPATH=$(pwd)
# remove hidden file
rm doc/_build/html/.buildinfo


%install
SETUPTOOLS_SCM_PRETEND_VERSION=%{version}
%py3_install

%if %{with check}
%check
PYTEST_SELECT='not test_popen_io[gevent-sys.executable]'
PYTEST_SELECT+=' and not [gevent-socket]'
PYTEST_SELECT+=' and not [eventlet-socket]'
PYTEST_SELECT+=' and not [python2.7]'
PYTHONPATH=$(pwd) \
py.test-%{python3_version} -r s \
  -k "$PYTEST_SELECT" \
  testing \
  --timeout=30
%endif

%files -n python3-%{srcname}
%{python3_sitelib}/%{srcname}*/
%license LICENSE

%files -n python3-%{srcname}-doc
%doc README.rst
%doc doc/_build/html
%doc CHANGELOG.rst

%changelog
* Fri Mar 17 2023 happy_orange <songnannan@linux.alibaba.com> - 1.9.0-1
- package init from upstream
